unit hiElem;

interface

uses Kol,Share,Debug,sqLite3Api;

type
  THIElem = class(TDebug)
   private
   public
    _prop_Pack:string;

    _data_Pack:THI_Event;
    _event_onGroupExists:THI_Event;
    _event_onEnumElements:THI_Event;
    _event_onResult:THI_Event;
    _event_onEnumTabs:THI_Event;
    _event_onElementExists:THI_Event;
    _event_onTabByElem:THI_Event;

    procedure _work_doOpenDB(var _Data:TData; Index:word);
    procedure _work_doCloseDB(var _Data:TData; Index:word);
    procedure _work_doCreateHiAsmDB(var _Data:TData; Index:word);
    procedure _work_doAddGroup(var _Data:TData; Index:word);
    procedure _work_doAddElement(var _Data:TData; Index:word);
    procedure _work_doEnumTabs(var _Data:TData; Index:word);
    procedure _work_doEnumElements(var _Data:TData; Index:word);
    procedure _work_doGroupExists(var _Data:TData; Index:word);
    procedure _work_doElementExists(var _Data:TData; Index:word);
    procedure _work_doDeleteElement(var _Data:TData; Index:word);
    procedure _work_doInstallEl(var _Data:TData; Index:word);
    procedure _work_doRemoveFromName(var _Data:TData; Index:word);
    procedure _work_doUnInstallEl(var _Data:TData; Index:word);
    procedure _work_doInstallPackage(var _Data:TData; Index:word);
    procedure _work_doTabByElem(var _Data:TData; Index:word);
    procedure _work_doShiftTab(var _Data:TData; Index:word);
    procedure _work_doShiftEl(var _Data:TData; Index:word);
  end;

implementation
type
  TEnumTabsProc = procedure (Name,Info:PChar; user:pointer); stdcall;

//procedure OpenDB(dbname:PChar); stdcall; external 'elmen.dll';
//procedure CloseDB; stdcall; external 'elmen.dll';
procedure CreateHiAsmDB; stdcall; external 'elmen.dll';
procedure AddGroup(name, info:PChar); stdcall; external 'elmen.dll';
procedure AddElement(id, name, group:PChar); stdcall; external 'elmen.dll';
procedure EnumTabs(proc:TEnumTabsProc; user:pointer); stdcall; external 'elmen.dll';
procedure EnumElements(tab:PChar; proc:TEnumTabsProc; user:pointer); stdcall; external 'elmen.dll';
function GroupExists(name:PChar):boolean; stdcall; external 'elmen.dll';
function ElementExists(name:PChar):boolean; stdcall; external 'elmen.dll';
procedure DeleteElement(name:PChar); stdcall; external 'elmen.dll';
//procedure TabByElem(name:pchar); stdcall; external 'elmen.dll';
procedure InstallEl(fn:PChar); stdcall; external 'hitools.dll';
procedure RemoveFromName(Name,fdir:PChar); stdcall; external 'hitools.dll';
procedure UnInstallEl(fn:PChar); stdcall; external 'hitools.dll';
procedure InstallPackage(fn:pchar); stdcall; external 'hitools.dll';
//procedure TabByEl(name, fdir:pchar); stdcall; external 'hitools.dll';

procedure THIElem._work_doOpenDB;
begin

end;

procedure THIElem._work_doCloseDB;
begin

end;

procedure THIElem._work_doCreateHiAsmDB;
begin

end;

procedure THIElem._work_doAddGroup;
begin

end;

procedure THIElem._work_doAddElement;
begin

end;

procedure THIElem._work_doEnumTabs;
begin

end;

procedure THIElem._work_doEnumElements;
begin

end;

procedure THIElem._work_doGroupExists;
begin

end;

procedure THIElem._work_doElementExists;
begin

end;

procedure THIElem._work_doDeleteElement;
begin

end;

procedure THIElem._work_doInstallEl;
begin
  InstallEl(PChar(toString(_Data)));
end;

procedure THIElem._work_doRemoveFromName;
begin
  RemoveFromName(PChar(toString(_Data)),PChar(ReadString(_Data, _Data_Pack, _prop_Pack)));
end;

procedure THIElem._work_doUnInstallEl;
begin
  UnInstallEl(PChar(toString(_Data)));
end;

procedure THIElem._work_doInstallPackage;
begin

end;

//###############  
var db:Pointer;
procedure OpenDB(dbname:PChar); stdcall;
begin
  checkSqliteLoaded;
  sqlite3_open(dbname, db);
end;

procedure CloseDB; stdcall;
begin
  sqlite3_close(db);
end;

function empty_callback(user:pointer; ncols:integer; values:ppchar; names:ppchar):integer; cdecl;
begin
   Result := 0;
end;

procedure exec(const s:string);
var
    ErrMsg:PChar;
begin
  sqlite3_exec(db, PChar(s), empty_callback, nil, @ErrMsg);
  {if ErrMsg <> '' then
    MessageBox(0,ErrMsg,'Error!!',MB_OK);}
end;
 
function query(const s:string):pointer;
var
    tail:PChar;
begin
  sqlite3_prepare(db, PChar(s), -1, Result, tail);
end;

function TabByEl(name:pchar):pchar;
Var p: string;
    r: pointer;
begin
   r := query('select groups.name, groups.info, groups.pos, groups.id from groups left join elements on groups.id=tab where elements.id= '''+name+'''');
   sqlite3_step(r);
   p:=sqlite3_column_text(r,0)+',';
   p:=p+sqlite3_column_text(r,1)+',';
   p:=p+Int2Str(sqlite3_column_int(r,2))+',';
   p:=p+Int2Str(sqlite3_column_int(r,3));
   sqlite3_finalize(r);
   result:=PChar(p);
end;

function TabByElem(name, fdir:pchar):pchar;
Var p: string;
begin
   p := GetStartDir + 'Elements\' + fdir + '\Elements.db';
   if not FileExists(p) then exit;
   OpenDB(PChar(p));
   result:=TabByEl(name);
   CloseDB;
end;

function TabPos(Name: pchar):integer;
Var r: pointer;
begin
  r := query('select pos from groups where name = ''' + Name + '''');
  sqlite3_step(r); result := sqlite3_column_int(r,0); sqlite3_finalize(r);
end;

procedure MoveTab(name: pchar; nPos:Integer);
Var p: string;
    r: pointer;
    oPos, gmax: integer;
begin
  oPos:=TabPos(name);
  if (oPos = 0) or (nPos=oPos) then exit;
  if nPos<1 then nPos:=1;
  r := query('select MAX(pos) from groups');
  sqlite3_step(r); gmax := sqlite3_column_int(r,0); sqlite3_finalize(r);
  if nPos>gmax then nPos:=gmax;
  if nPos>oPos then
    exec('UPDATE groups SET pos=pos-1 WHERE pos>'+Int2Str(oPos)+' and pos<='+Int2Str(nPos))    
   else 
    exec('UPDATE groups SET pos=pos+1 WHERE pos>='+Int2Str(nPos)+' and pos<'+Int2Str(oPos));
  exec('UPDATE groups SET pos='+Int2Str(nPos)+' WHERE name='''+name+'''');    
end;

procedure ShiftTab(name, fdir:pchar; ShiftPos:Integer); {+1 down, -1 up }
Var p: string;
    r: pointer;
begin
   p := GetStartDir + 'Elements\' + fdir + '\Elements.db';
   if not FileExists(p) then exit;
   OpenDB(PChar(p));  // msgbox(p+','+name+','+int2str(shiftpos),1);
   MoveTab(name, TabPos(name)+ShiftPos);
   CloseDB;
end;

procedure ElInfo(id: pchar; var tab,Pos:integer);
Var r: pointer;
begin
  r := query('select tab,pos from elements where id = ''' + id + '''');
  sqlite3_step(r); 
  tab := sqlite3_column_int(r,0);
  pos := sqlite3_column_int(r,1);
  sqlite3_finalize(r);
end;

procedure MoveEl(id: pchar; nPos:Integer);
Var p: string;
    r: pointer;
    oTab, oPos, elMax: integer;
begin
  ElInfo(id, oTab, oPos);
  if (oPos = 0) or (nPos=oPos) then exit;
  if nPos<1 then nPos:=1;
  r := query('select MAX(pos) from elements where tab='+int2str(oTab));
  sqlite3_step(r); elMax := sqlite3_column_int(r,0); sqlite3_finalize(r);
  if nPos>elmax then nPos:=elmax;
  if nPos>oPos then
    exec('UPDATE elements SET pos=pos-1 WHERE tab='+int2str(oTab)+' and pos>'+Int2Str(oPos)+' and pos<='+Int2Str(nPos))    
   else 
    exec('UPDATE elements SET pos=pos+1 WHERE tab='+int2str(oTab)+' and pos>='+Int2Str(nPos)+' and pos<'+Int2Str(oPos));
  exec('UPDATE elements SET pos='+Int2Str(nPos)+' WHERE tab='+int2str(oTab)+' and id='''+id+'''');    
end;

procedure ShiftEl(ElId, fdir:pchar; ShiftPos:Integer); {+1 down, -1 up }
Var p: string;
    r: pointer;
    t,opos:Integer;
begin
   p := GetStartDir + 'Elements\' + fdir + '\Elements.db';
   if not FileExists(p) then exit;
   OpenDB(PChar(p));  // msgbox(p+','+ElId+','+int2str(shiftpos),1);
   ElInfo(ElId, t,opos);
   MoveEl(ElId, opos + ShiftPos);
   CloseDB;
end;


//##################################}


procedure THIElem._work_doTabByElem;
var p: PChar;
begin
  p:=TabByElem(PChar(toString(_Data)),PChar(ReadString(_Data, _Data_Pack, _prop_Pack)));
  _hi_CreateEvent(_Data,@_event_onTabByElem, p);
end;

procedure THIElem._work_doShiftTab;
var s,fdir:string;
    VD:THI_Event;
begin
  VD.event:=nil;
  fdir:=ReadString(_Data, _Data_Pack, _prop_Pack);
  s:=ReadString(_Data, VD, '');
  s:=TabByElem(PChar(s),PChar(fdir)); //      
  //           
  shiftTab(PChar(gettok(s,',')),PChar(fdir),ReadInteger(_Data, VD,0));
end;

procedure THIElem._work_doShiftEl;
var s,fdir:string;
    VD:THI_Event;
begin
  VD.event:=nil;
  fdir:=ReadString(_Data, _Data_Pack, _prop_Pack);
  s:=ReadString(_Data, VD, '');
  shiftEl(PChar(s),PChar(fdir),ReadInteger(_Data, VD,0));
end;

end.
